// =================================================================================================
// -------------------------------------------------------------------------------------------------
// SSF Extractor
// -------------------------------------------------------------------------------------------------

#include <stdio.h>
#include <direct.h>
#include "Memory.h"

// =================================================================================================
// -------------------------------------------------------------------------------------------------
// Subroutine to write a value into the list
// -------------------------------------------------------------------------------------------------

void WriteValue (int Value, FILE *List)

{
	int i0, i1, i2, i3, i4, i5, i6, i7;
	for (i1 = 0x00; i1 != 0x08; i1++)
	{
		i0 = Value >> 0x1C & 0x0F;
		Value <<= 0x04;
		i0 += '0';
		if (i0 > '9')
		{
			i0 += 'A' - ('9' + 0x01);
		}
		fputc (i0, List);
	}
}

// =================================================================================================
// -------------------------------------------------------------------------------------------------
// Subroutine to extract a .ssf ( CES) file
// -------------------------------------------------------------------------------------------------

void ExtractFile (char *Directory)

{
	int DirectoryLoc, i0, i1, i2, i3, i4, i5, i6, i7;
	int FileCount, FileSize, Type, Offset, Size, Name, Fail = 0x00;
	FILE *Input;
	if ((Input = fopen (Directory, "rb")) == NULL)
	{
		printf ("    Error: Could not open file\n");
	}
	else
	{
		i0 = (fgetc (Input) & 0xFF) << 0x18;
		i0 |= (fgetc (Input) & 0xFF) << 0x10;
		i0 |= (fgetc (Input) & 0xFF) << 0x08;
		i0 |= fgetc (Input) & 0xFF;
		if (i0 != 0x20434553) // " CES"
		{
			fclose (Input);
			printf ("    Error: The file is not a valid .ssf ( CES) file\n");
		}
		else
		{
			fseek (Input, 0x00, SEEK_END);
			char *Memory = NULL; int MemorySize = 0x00, MemoryLoc = 0x00;
			AllocChar (Memory, MemorySize, ftell (Input));
			rewind (Input);
			fread (Memory, MemorySize, 0x01, Input);
			fclose (Input);

			// === Making directory ===

			char Extension [0x0400];
			for (DirectoryLoc = 0x00, i1 = 0x00, i2 = 0x00, i0 = Directory [++i1] & 0xFF; i0 != 0x00; )
			{
				if (i0 == '.')
				{
					DirectoryLoc = i1;
					i2 = 0x00;
				}
				if (DirectoryLoc != 0x00)
				{
					Extension [i2++] = i0;
				}
				i0 = Directory [++i1];
			}
			Extension [i2] = 0x00;
			if (DirectoryLoc == 0x00)
			{
				DirectoryLoc = i1;
			}
			Directory [DirectoryLoc] = 0x00;
			mkdir (Directory);
			Directory [DirectoryLoc] = '/';

			// === Making list ===

			char ListName [] = "00_OrderList.txt";
			for (i1 = 0x00, i2 = DirectoryLoc + 0x01, i0 = ' '; i0 != 0x00; )
			{
				i0 = ListName [i1++] & 0xFF;
				Directory [i2++] = i0;
			}
			FILE *List = fopen (Directory, "wb");
			fputs (Extension, List); fputc (0x0D, List); fputc (0x0A, List);

			// === Reading Header ===

			MemoryLoc = 0x04;

			fputs ("; Offset - Value", List); fputc (0x0D, List); fputc (0x0A, List);

			WriteValue (MemoryLoc, List); fputc (' ', List);
			i0 = Memory [MemoryLoc++] & 0xFF;
			i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
			i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
			i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x18;
			WriteValue (i0, List); fputc (' ', List); fputc (0x0D, List); fputc (0x0A, List);

			WriteValue (MemoryLoc, List); fputc (' ', List);
			i0 = Memory [MemoryLoc++] & 0xFF;
			i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
			i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
			i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x18;
			WriteValue (i0, List); fputc (' ', List); fputc (0x0D, List); fputc (0x0A, List);

			WriteValue (MemoryLoc, List); fputc (' ', List);
			i0 = Memory [MemoryLoc++] & 0xFF;
			i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
			i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
			i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x18;
			WriteValue (i0, List); fputc (' ', List); fputc (0x0D, List); fputc (0x0A, List);

			FileCount = Memory [MemoryLoc++] & 0xFF;
			FileCount |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
			FileCount |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
			FileCount |= (Memory [MemoryLoc++] & 0xFF) << 0x18;

			WriteValue (MemoryLoc, List); fputc (' ', List);
			i0 = Memory [MemoryLoc++] & 0xFF;
			i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
			i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
			i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x18;
			WriteValue (i0, List); fputc (' ', List); fputc (0x0D, List); fputc (0x0A, List);

			FileSize = Memory [MemoryLoc++] & 0xFF;
			FileSize |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
			FileSize |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
			FileSize |= (Memory [MemoryLoc++] & 0xFF) << 0x18;

			// === Extracting Files ===

			fputs ("; List (Type - Creation type (0 = From archieve | Non-0 = Created) - Filename)", List); fputc (0x0D, List); fputc (0x0A, List);
			char FileName [0x0400];
			char BinaryName [] = ".bin";
			char SSFName [] = ".ssf";
			printf ("    Extracting:\n\n");
			for (i7 = 0x00; i7 < FileCount && Fail == 0x00; i7++)
			{
				Type = Memory [MemoryLoc++] & 0xFF;
				Type |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
				Type |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
				Type |= (Memory [MemoryLoc++] & 0xFF) << 0x18;
				WriteValue (Type, List); fputc (' ', List);
				Offset = Memory [MemoryLoc++] & 0xFF;
				Offset |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
				Offset |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
				Offset |= (Memory [MemoryLoc++] & 0xFF) << 0x18;
				Size = Memory [MemoryLoc++] & 0xFF;
				Size |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
				Size |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
				Size |= (Memory [MemoryLoc++] & 0xFF) << 0x18;
				Name = Memory [MemoryLoc++] & 0xFF;
				Name |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
				Name |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
				Name |= (Memory [MemoryLoc++] & 0xFF) << 0x18;
				Name += (FileCount * 0x10) + 0x1C;
				i0 = (Memory [Offset] & 0xFF) << 0x18;
				i0 |= (Memory [Offset + 0x01] & 0xFF) << 0x10;
				i0 |= (Memory [Offset + 0x02] & 0xFF) << 0x08;
				i0 |= Memory [Offset + 0x03] & 0xFF;
				char *ExtendName = SSFName;
				if (i0 != 0x20434553) // " CES"
				{
					ExtendName = BinaryName;
				}
				if (Name < 0x00 || Name > FileSize)
				{
					char UnknownName [] = "Unknown";
					for (i1 = -0x01, i4 = DirectoryLoc, i0 = ' '; i0 != 0x00; )
					{
						i0 = UnknownName [++i1] & 0xFF;
						FileName [i1] = i0;
						Directory [++i4] = i0;
					}
					for (i2 = 0x08, i3 = i7; i2 != 0x00; i2--)
					{
						i0 = (i3 >> 0x1C) & 0x0F;
						i3 <<= 0x04;
						i0 += '0';
						if (i0 > '9')
						{
							i0 += 'A' - ('9' + 0x01);
						}
						FileName [i1++] = i0;
						Directory [i4++] = i0;
					}
					for (i2 = -0x01, i0 = ' '; i0 != 0x00; )
					{
						i0 = ExtendName [++i2] & 0xFF;
						FileName [i1++] = i0;
						Directory [i4++] = i0;
					}
					WriteValue (Name - ((FileCount * 0x10) + 0x1C), List); fputc (' ', List);
					fputs (FileName, List); fputc (' ', List);
				}
				else
				{
					for (i1 = -0x01, i4 = DirectoryLoc, i0 = ' '; i0 != 0x00; )
					{
						i0 = Memory [Name++] & 0xFF;
						FileName [++i1] = i0;
						Directory [++i4] = i0;
					}
					for (i2 = -0x01, i0 = ' '; i0 != 0x00; )
					{
						i0 = ExtendName [++i2] & 0xFF;
						FileName [i1++] = i0;
						Directory [i4++] = i0;
					}
					fputc ('0', List); fputc (' ', List);
					fputs (FileName, List); fputc (' ', List);
				}
				printf ("    > %s\n", FileName);
				FILE *Output;
				if ((Output = fopen (Directory, "wb")) == NULL)
				{
					printf ("      Error: Could not create the file, Halting process...\n");
					fseek (List, 0x00, SEEK_SET);
					fputs ("ERROR, Extraction failed...", List);
					Fail = 0x01;
				}
				else
				{
					for (i0 = 0x00; i0 < Size; i0++)
					{
						fputc (Memory [Offset++], Output);
					}
					fclose (Output);
				}
				fputc (0x0D, List); fputc (0x0A, List);
			}

			// === Finish ===

			free (Memory);
			fclose (List);
		}
	}
}

// =================================================================================================
// -------------------------------------------------------------------------------------------------
// Main routine
// -------------------------------------------------------------------------------------------------

int main (int ArgNumber, char **ArgList, char **EnvList)

{
	printf (".ssf ( CES) Extractor - by MarkeyJester\n");
	int ArgCount, i0, i1, i2, i3, i4, i5, i6, i7;
	if (ArgNumber <= 0x01)
	{
		printf ("\n -> Drag and drop .ssf ( CES) files onto this application\n");
	}
	else
	{
		char Directory [0x0400];
		for (ArgCount = 0x01; ArgCount < ArgNumber; ArgCount++)
		{
			char *ArgListPointer = ArgList [ArgCount];
			for (i0 = ' ', i1 = 0x00; i0 != 0x00; )
			{
				i0 = ArgListPointer [i1] & 0xFF;
				Directory [i1++] = i0;
			}
			printf ("\n -> %s\n", Directory);
			ExtractFile (Directory);
		}
	}
	printf ("\nPress enter key to exit...\n");
	fflush (stdin);
	getc (stdin);
	return (0x00);
}

// =================================================================================================
